property spriteNum, pOriWidth, pOriHeight, pAfstand, pGrootte, pVergroting, pGaan, pGroep, lDoe, pMemberColor, pMemberDuoTone

on new me, spritenummer, groep
  spriteNum = spritenummer
  changemember(me, sprite(spriteNum).member)
  pGroep = groep
  pVergroting = 3
  pGrootte = 1.0 / pVergroting
  init()
  pGaan = 0
  add(the actorList, me)
  return me
end

on changemember me, membernummer
  pMemberColor = membernummer
  pMemberDuoTone = member(pMemberColor).memberNum + 150
  member(pMemberDuoTone).regPoint = member(pMemberColor).regPoint
  sprite(spriteNum).member = pMemberDuoTone
end

on init me
  pOriWidth = sprite(spriteNum).width * pVergroting
  pOriHeight = sprite(spriteNum).height * pVergroting
  pAfstand = 75
  pGrootte = 1 - pGrootte
end

on endSprite me
  deleteOne(the actorList, me)
end

on stopgroei me, groep
  if groep = pGroep then
    pGaan = 0
    sprite(spriteNum).member = pMemberDuoTone
  end if
end

on startgroei me, groep
  if groep = pGroep then
    pGaan = 1
  end if
end

on stepFrame
  if pGaan then
    x = sqrt(power(the mouseH - sprite(spriteNum).locH, 2) + power(the mouseV - sprite(spriteNum).locV, 2))
    if x <= pAfstand then
      if not lDoe then
        sprite(spriteNum).member = pMemberColor
      end if
      lDoe = 1
    else
      x = pAfstand
      if lDoe then
        proces(x)
      end if
      sprite(spriteNum).member = pMemberDuoTone
      lDoe = 0
    end if
    if lDoe then
      proces(x)
    end if
  end if
end

on proces x
  x = x / pAfstand
  p = abs(x - 1)
  lLocz = (p * 5) - 5
  sprite(spriteNum).locZ = lLocz
  sprite(spriteNum).width = pOriWidth - (x * pGrootte * pOriWidth)
  sprite(spriteNum).height = pOriHeight - (x * pGrootte * pOriHeight)
end
