property pMax, pProcent, pFrames, pStart, spriteNum, pAmp, pFrameTeller, pAmpCos, pKopMember, pAction, pJumpy

on beginSprite me
  add(the actorList, me)
  pStart = 0
  pFrameTeller = 1
  sprite(spriteNum).height = 3
  pAmp = pMax * pProcent / 100
  pAmpCos = pAmp
  sprite(spriteNum).member.regPoint = point(0, sprite(spriteNum).member.height)
  sprite(pKopMember).locV = sprite(spriteNum).top
  sprite(pKopMember).locH = sprite(spriteNum).locH
end

on endSprite me
  sprite(spriteNum).height = sprite(spriteNum).member.height
  sprite(pKopMember).locV = sprite(spriteNum).top
  updateStage()
  deleteOne(the actorList, me)
end

on Ontvang me, what
  if (pAction = what) and (pFrameTeller = 1) then
    pStart = 1
  end if
end

on stepFrame me
  if pStart then
    x = ((pFrameTeller - 1) * 99.0 / (pFrames - 1.0)) + 1
    y = 100 / x
    pAmpCos = (y - 1) / 99 * pAmp
    sprite(spriteNum).height = (-1 * (cos(pJumpy * PI * pFrameTeller / pFrames) * pAmpCos)) + pAmp
    sprite(pKopMember).locV = sprite(spriteNum).top
    if (pFrameTeller + 1) > pFrames then
      pStart = 0
    else
      pFrameTeller = pFrameTeller + 1
    end if
  end if
end

on getPropertyDescriptionList me
  sprtnmkop = the currentSpriteNum + 1
  propertyList = [:]
  setaProp(propertyList, #pMax, [#comment: "kies een maximum(100 %) in pixels", #format: #integer, #default: 300])
  setaProp(propertyList, #pProcent, [#comment: "Kies een percentage staaf hoogte van max", #format: #integer, #default: 85, #range: [#min: 1, #max: 100]])
  setaProp(propertyList, #pFrames, [#comment: "hoeveel frames duurt de animatie", #format: #integer, #default: 30])
  setaProp(propertyList, #pKopMember, [#comment: "Wat is de sprite waar de kop van de diagram in zit?", #format: #integer, #default: sprtnmkop])
  setaProp(propertyList, #pAction, [#comment: "Wat is het beginsigneel", #format: #string, #default: "staaf"])
  setaProp(propertyList, #pJumpy, [#comment: "Hoe 'jumpy' moet de diagram zijn?", #format: #integer, #default: 10, #range: [#min: 2, #max: 30]])
  return propertyList
end
