property spriteNum, pShow, pBlend, pStapjes, Pmsg, pMaxVisible

on new me
  return me
end

on beginSprite me
  pShow = 1
  pBlend = 0
  sprite(spriteNum).blend = pBlend
  add(the actorList, me)
end

on endSprite me
  new(script("hide in .. steps"), 50, pStapjes, sprite(spriteNum).blend, sprite(spriteNum).member, sprite(spriteNum).rect, sprite(spriteNum).locZ, sprite(spriteNum).color)
  deleteOne(the actorList, me)
end

on exitFrame me
  if pShow then
    go(the frame)
  end if
end

on stepFrame
  if pShow then
    sprite(spriteNum).blend = pBlend
    pBlend = pBlend + (pMaxVisible / pStapjes)
    if pBlend >= pMaxVisible then
      pShow = 0
      sprite(spriteNum).blend = pMaxVisible
    end if
  end if
end

on getPropertyDescriptionList me
  propertyList = [:]
  setaProp(propertyList, #pStapjes, [#comment: "hoeveel stapjes duurt de animatie?", #format: #integer, #default: 30])
  setaProp(propertyList, #Pmsg, [#comment: "welke msg sent ie uit als ie klaar is?", #format: #symbol, #default: #Msg])
  setaProp(propertyList, #pMaxVisible, [#comment: "max visible", #format: #integer, #default: 80])
  return propertyList
end
